﻿
***variable level xxx (scale) (ordinal) (nominal )     .


****To ID, living in maids .

cd 'C:\1 Barbados\analisys'  .

GET  FILE='02 person_01-10.sav'
    keep =  hhid_string hhid q1_02 .

***leave only cases with domestic servents .

FILTER OFF.
USE ALL.
SELECT IF (q1_02 = 10).
EXECUTE.

SORT CASES BY hhid(A).

compute living_sevents = 1 .
execute .

compute nonfoodc = 2001 .
execute .

delete variable q1_02 .

SAVE OUTFILE='c hh with sevents.sav'
  /COMPRESSED.

***********.

GET FILE='c hh with sevents.sav'.

   *********************************************                   NON-FOOD                 ********************************************* .
   *********************************************                   NON-FOOD                 ********************************************* .
   *********************************************                   NON-FOOD                 ********************************************* .
   *********************************************                   NON-FOOD                 ********************************************* .
   *********************************************                   NON-FOOD                 ********************************************* .

cd 'C:\1 Barbados\analisys'  .

GET FILE='11 non_food_14b-d.sav'.

compute nonfoodc_original = nonfoodc .
execute .

variable level nonfoodc  (nominal )     .

***50,634 cases

AUTORECODE VARIABLES=q14_1n 
  /INTO Others
  /PRINT.

***11 

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1105 and nonfoodc < 1106).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1105 'Others'
1106 'Land rent'
1107 'Rent and utilities'
1199 'Non consumption aggregate'.

RECODE Others ( 248  =  1199) ( 498  =  1199) ( 712  =  1104) 
( 728  =  1104) ( 729  =  1104) ( 805  =  1106) ( 806  =  1106) ( 807  =  1106) 
( 808  =  1106) ( 810  =  1106) ( 811  =  1106) ( 812  =  1106) ( 813  =  1106) 
( 814  =  1199) ( 842  =  1702) ( 845  =  1702) ( 866  =  1799) ( 879  =  1799) 
( 922  =  1199) ( 923  =  1199) ( 924  =  1199) ( 1030  =  1199) ( 1159  =  1107) 
( 1160  =  1107) ( 1161  =  1107) ( 1162  =  1107) ( 1163  =  1107) ( 1164  =  1107) 
INTO nonfoodc.
EXECUTE.

***  12

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1207 and nonfoodc < 1210).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1207 'Other light and fuel'
1208 'Other water or light'
1299 'Non consumption aggregate'.

RECODE Others ( 137  =  1207) ( 219  =  1207) ( 224  =  1207) 
( 716  =  1207) ( 785  =  1207) ( 848  =  1207) ( 849  =  1207) 
( 850  =  1207) ( 851  =  1207) ( 852  =  1207) ( 1041  =  1299) 
( 1045  =  1804) ( 1052  =  1208) ( 1236  =  1207) ( 1518  =  1208) ( 1526  =  1208) 
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc (1210=1207).
EXECUTE.

***   13

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1301 and nonfoodc < 1309).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1307 'Other soaps and detergents'
1308 'Other similar cleaning products'

RECODE Others  ( 29  =  1308) ( 37  =  1308) ( 39  =  1308) ( 40  =  1308) ( 44  =  1308) ( 49  =  1308) 
( 65  =  1308) ( 68  =  1308) ( 69  =  1308) ( 70  =  1308) ( 74  =  1308) ( 79  =  1307) ( 89  =  1308) 
( 96  =  1307) ( 124  =  1308) ( 125  =  1308) ( 306  =  1308) ( 314  =  1308) ( 318  =  1308) ( 319  =  1308) 
( 405  =  1307) ( 406  =  1307) ( 417  =  1307) ( 420  =  1307) ( 421  =  1307) ( 422  =  1307) ( 423  =  1307) 
( 427  =  1307) ( 429  =  1307) ( 430  =  1307) ( 431  =  1307) ( 432  =  1307) ( 433  =  1307) ( 434  =  1307) 
( 436  =  1307) ( 437  =  1307) ( 439  =  1307) ( 440  =  1307) ( 441  =  1307) ( 443  =  1307) ( 444  =  1307) 
( 445  =  1307) ( 446  =  1307) ( 449  =  1307) ( 450  =  1307) ( 451  =  1307) ( 452  =  1307) ( 454  =  1307) 
( 455  =  1307) ( 456  =  1307) ( 457  =  1307) ( 458  =  1307) ( 459  =  1307) ( 460  =  1307) ( 461  =  1307) 
( 462  =  1308) ( 463  =  1308) ( 465  =  1307) ( 469  =  1307) ( 470  =  1307) ( 488  =  1308) ( 522  =  1308) 
( 523  =  1308) ( 524  =  1308) ( 527  =  1308) ( 528  =  1308) ( 529  =  1308) ( 530  =  1308) ( 531  =  1308) 
( 532  =  1308) ( 533  =  1308) ( 534  =  1308) ( 535  =  1308) ( 536  =  1308) ( 537  =  1308) ( 538  =  1308) 
( 539  =  1308) ( 545  =  1308) ( 552  =  1308) ( 579  =  1308) ( 580  =  1308) ( 610  =  1307) ( 671  =  1307) 
( 674  =  1307) ( 675  =  1307) ( 676  =  1307) ( 677  =  1307) ( 686  =  1307) ( 752  =  1307) ( 753  =  1307) 
( 766  =  1307) ( 784  =  1307) ( 825  =  1307) ( 855  =  1307) ( 858  =  1307) ( 876  =  1308) ( 915  =  1308) 
( 976  =  1308) ( 982  =  1308) ( 983  =  1308) ( 984  =  1308) ( 985  =  1308) ( 1063  =  1308) ( 1136  =  1308) 
( 1146  =  1308) ( 1147  =  1308) ( 1271  =  1308) ( 1293  =  1307) ( 1301  =  1308) ( 1302  =  1308) 
( 1303  =  1307) ( 1304  =  1307) ( 1305  =  1307) ( 1306  =  1307) ( 1307  =  1307) ( 1308  =  1307) 
( 1317  =  1307) ( 1326  =  1307) ( 1327  =  1307) ( 1328  =  1307) ( 1329  =  1307) ( 1350  =  1307) 
( 1351  =  1307) ( 1391  =  1307) ( 1411  =  1307) ( 1489  =  1307) ( 1495  =  1307) ( 1496  =  1307) 
( 1497  =  1307) ( 1498  =  1307) 
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc (1309=1308).
EXECUTE.

***   14 Other cleaning

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1406 and nonfoodc < 1409).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1406 'Other cleaning material'

RECODE Others  ( 75  =  1406) ( 201  =  1406) ( 202  =  1406) ( 209  =  1406) 
( 236  =  1507) ( 311  =  1406) ( 312  =  1406) ( 334  =  1406) ( 424  =  1406) 
( 425  =  1406) ( 428  =  1406) ( 435  =  1406) ( 447  =  1406) ( 448  =  1406) 
( 453  =  1406) ( 464  =  1406) ( 490  =  1406) ( 540  =  1406) ( 597  =  1406) 
( 618  =  1406) ( 764  =  1406) ( 765  =  1406) ( 854  =  1406) ( 864  =  1406) 
( 875  =  1406) ( 906  =  1406) ( 918  =  1406) ( 919  =  1406)( 920  =  1406) 
( 921  =  1406) ( 928  =  1507) ( 940  =  1406) ( 1062  =  1406) ( 1073  =  1406) 
( 1094  =  1406) ( 1174  =  1406) ( 1233  =  1406) ( 1272  =  1406) ( 1318  =  1406) 
( 1319  =  1406) ( 1321  =  1406) ( 1322  =  1406) ( 1323  =  1406) ( 1325  =  1406) 
( 1397  =  1406) ( 1516  =  1406) ( 1528  =  1406) ( 1533  =  1406) ( 1534  =  1406) 
( 1535  =  1406) ( 1536  =  1406) ( 1537  =  1406) ( 1566  =  1406) 
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc  (1407=1406)  (1409=1406).
EXECUTE.

***   15 Household supplies .

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1507 and nonfoodc < 1508).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1507 'Other Household supplies'

RECODE Others  ( 85  =  1507) ( 139  =  1207) ( 210  =  1507) ( 236  =  1507) 
( 307  =  1507) ( 308  =  1507) ( 309  =  1507) ( 315  =  1507) ( 316  =  1507) 
( 317  =  1507) ( 402  =  1507) ( 403  =  1507) ( 404  =  1507) ( 588  =  1507) 
( 589  =  1507) ( 598  =  1507) ( 599  =  1507) ( 600  =  1507) ( 601  =  1507) 
( 602  =  1507) ( 606  =  1507) ( 673  =  1406) ( 719  =  1507) ( 721  =  1507) 
( 722  =  1507) ( 723  =  1507) ( 724  =  1507) ( 725  =  1507) ( 838  =  1507) 
( 904  =  1507) ( 927  =  1507) ( 928  =  1507) ( 929  =  1507) ( 1027  =  1507) 
( 1028  =  1507) ( 1042  =  1507) ( 1043  =  1507) ( 1070  =  1507) ( 1074  =  1507) 
( 1075  =  1507) ( 1076  =  1507) ( 1104  =  1507) ( 1117  =  1507) ( 1152  =  1507) 
( 1153  =  1507) ( 1168  =  1507) ( 1169  =  1507) ( 1170  =  1507) ( 1188  =  1507) 
( 1240  =  1507) ( 1245  =  1507) ( 1246  =  1507) ( 1247  =  1507) ( 1248  =  1507) 
( 1249  =  1507) ( 1291  =  1507) ( 1341  =  1507) ( 1388  =  1507) ( 1415  =  1507) 
( 1527  =  1507) ( 1562  =  1507) 
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc (1508=1507).
EXECUTE.

***   16 Personal cares .

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1617 and nonfoodc < 1621).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1617 'OtherHousehold supplies'

RECODE nonfoodc (1617 thru 1621=1617).
EXECUTE.

***   17 Medical expenses.

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1702 and nonfoodc < 1703).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1702 'Life insurance'
 1799 'Non consumption aggregate'.

RECODE Others  ( 301  =  1799) ( 639  =  1701) ( 696  =  1701) 
( 731  =  1801) ( 839  =  1702) ( 840  =  1702) ( 841  =  1702) ( 844  =  1702) 
( 1029  =  1799) ( 1068  =  1799) ( 1313  =  1799) 
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc (1703 =1701).
EXECUTE.

***   18 Comunications

USE ALL.
COMPUTE filter_$=(nonfoodc >= 1803 and nonfoodc < 1804).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
1803 'Other phone charges' 
1899 'Non consumption'

RECODE Others  ( 225  =  1801) ( 226  =  1801) ( 227  =  1801) ( 228  =  1801) ( 230  =  1801) 
( 382  =  1899) ( 383  =  1899) ( 418  =  1801) ( 419  =  1801) ( 568  =  1899) ( 731  =  1801) 
( 732  =  1801) ( 733  =  1801) ( 734  =  1801) ( 735  =  1801) ( 736  =  1801) ( 737  =  1801) 
( 738  =  1801) ( 739  =  1801) ( 740  =  1801) ( 741  =  1801) ( 742  =  1801) ( 743  =  1801) 
( 816  =  1801) ( 817  =  1801) ( 818  =  1801) ( 853  =  1801) ( 898  =  1801) ( 911  =  1802) 
( 912  =  1802) ( 948  =  1617) ( 1046  =  1801) ( 1047  =  1801) ( 1048  =  1801) ( 1049  =  1801) 
( 1257  =  1617) ( 1385  =  1801) 
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc (1804 =1803).
EXECUTE.

***   20 Other services

USE ALL.
COMPUTE filter_$=(nonfoodc >= 2006 and nonfoodc < 2008).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2006 'Other services'
2099 'Non consumption'

RECODE Others  ( 77  =  2006) ( 116  =  2006) ( 192  =  2006) ( 233  =  2006) ( 255  =  2006) 
( 294  =  2099) ( 302  =  2099) ( 401  =  2006) ( 407  =  2006) ( 409  =  2006) ( 473  =  2006) 
( 499  =  2006) ( 520  =  2006) ( 521  =  2006) ( 603  =  2006) ( 604  =  2006) ( 650  =  2006) 
( 658  =  2006) ( 662  =  2006) ( 663  =  2006) ( 664  =  2006) ( 665  =  2006) ( 703  =  2006) 
( 706  =  2006) ( 824  =  2006) ( 829  =  2006) ( 843  =  1702) ( 844  =  1702) ( 887  =  2006) 
( 941  =  2006) ( 945  =  2006) ( 956  =  2099)( 957  =  2099) ( 958  =  2099) ( 959  =  2099) 
( 1103  =  2099) ( 1110  =  2006) ( 1119  =  1617) ( 1122  =  2006) ( 1131  =  1617)
 ( 1135  =  2006) ( 1314  =  2006) ( 1364  =  2006) ( 1416  =  2006)  
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc (2008 =2006).
EXECUTE.

***   21 clothes for men'

USE ALL.
COMPUTE filter_$=(nonfoodc >= 2116 and nonfoodc < 2121).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2117 'Other clothes for men'

RECODE nonfoodc (2117 thru 2121=2117).
EXECUTE.

***   22 clothes for wonmen'

USE ALL.
COMPUTE filter_$=(nonfoodc >=  2221 and nonfoodc < 2299).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2221 'Other clothes for women'

RECODE Others ( 1032  =  1617)  
INTO nonfoodc.
EXECUTE.


***   23 clothes for boys'

USE ALL.
COMPUTE filter_$=(nonfoodc >= 2317 and nonfoodc < 2321).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2317 'Other clothes for boys'
2399 'Non consumption agregate'


RECODE nonfoodc (2317 thru 2321=2317).
EXECUTE.

RECODE Others ( 1215  =  2399) ( 1216  =  2399) ( 1217  =  2399) 
( 1218  =  2399) ( 1219  =  2399) ( 1220  =  2399) 
INTO nonfoodc.
EXECUTE.

***   24 clothes for girls'

USE ALL.
COMPUTE filter_$=(nonfoodc >=  2420 and nonfoodc <= 2429).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2420 'Other clothes for girls'
2499 'Non consumption agregate'

RECODE nonfoodc (2420 thru 2421=2420).
EXECUTE.

RECODE Others ( 886  =  1617) ( 1215  =  2499) ( 1216  =  2499) ( 1219  =  2499) ( 1222  =  2499)  
INTO nonfoodc.
EXECUTE.

***   25 Other clothing and accessories

USE ALL.
COMPUTE filter_$=(nonfoodc >=  2509 and nonfoodc <= 2521).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2509 'Jewellery'
2510 'Other clothing and accessory'
2599 'Non consumption agregate'

RECODE Others ( 62  =  2510) ( 63  =  2510) ( 64  =  2510) ( 92  =  2510) ( 112  =  2510) ( 113  =  2510) 
( 114  =  2510) ( 115  =  2510) ( 117  =  2510) ( 118  =  2510) ( 119  =  2510) ( 120  =  2510) ( 121  =  2510) 
( 122  =  2510) ( 123  =  2510) ( 126  =  2510) ( 136  =  2510) ( 147  =  2510) ( 163  =  2509) ( 190  =  2509) 
( 231  =  2510) ( 240  =  2510) ( 359  =  2510) ( 360  =  2509) ( 361  =  2509) ( 362  =  2509) ( 363  =  2509) 
( 364  =  2509) ( 365  =  2509) ( 366  =  2509) ( 367  =  2509) ( 368  =  2509) ( 369  =  2509) ( 370  =  2509) 
( 384  =  2510) ( 398  =  2510) ( 494  =  2509) ( 495  =  2509) ( 496  =  2509) ( 497  =  2509) ( 526  =  2510) 
( 543  =  2509) ( 544  =  2509) ( 609  =  2510) ( 616  =  2510) ( 620  =  2504) ( 621  =  2504) ( 622  =  2504) 
( 667  =  2510) ( 668  =  2510) ( 669  =  2510) ( 670  =  2510) ( 678  =  2510) ( 679  =  2510) ( 680  =  2510) 
( 681  =  2510) ( 682  =  2510) ( 683  =  2510) ( 684  =  2510) ( 689  =  2510) ( 760  =  2509) ( 761  =  2509) 
( 762  =  2509) ( 763  =  2504) ( 872  =  2510) ( 874  =  2510) ( 950  =  2509) ( 953  =  2510) ( 1054  =  2509) 
( 1141  =  2510) ( 1142  =  2510) ( 1171  =  2510) ( 1209  =  2599) ( 1210  =  2599) ( 1211  =  2599) 
( 1212  =  2599) ( 1213  =  2599) ( 1214  =  2599) ( 1223  =  2599) ( 1235  =  2510) ( 1260  =  2510) 
( 1296  =  2510) ( 1330  =  2509) ( 1357  =  2510) ( 1366  =  2510) ( 1377  =  2510) ( 1463  =  2510) 
( 1486  =  2510) ( 1506  =  2510) ( 1517  =  2510) ( 1563  =  2510) ( 1564  =  2510) 
INTO nonfoodc.
EXECUTE.

***   28 Radio, TV, etc.

USE ALL.
COMPUTE filter_$=(nonfoodc >=  2808 and nonfoodc <= 2809).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2808 'Android devices'
2809 'Other electronics'
2810 'Other electonic accesories'

RECODE Others  ( 81  =  2808) ( 82  =  2808) ( 83  =  2808) ( 84  =  2808) ( 138  =  2810) 
( 140  =  2810) ( 258  =  2810) ( 356  =  2810) ( 357  =  2809) ( 491  =  2810) ( 492  =  2810) 
( 695  =  2810) ( 714  =  2809) ( 748  =  2809) ( 815  =  2810) ( 1044  =  2809) ( 1050  =  2810) 
( 1051  =  2810) ( 1109  =  2809) ( 1149  =  2809) ( 1264  =  2810) ( 1284  =  2810) ( 1338  =  2809) 
INTO nonfoodc.
EXECUTE.

USE ALL.
COMPUTE filter_$=(nonfoodc >=  2801 and nonfoodc <= 2810).
FILTER BY filter_$.
EXECUTE.

***   29 Furniture .

USE ALL.
COMPUTE filter_$=(nonfoodc >=  2916 and nonfoodc <= 2917).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
2916 'Other furniture'

RECODE nonfoodc (2916 thru 2917=2916).
EXECUTE.

***   30 HH applilances.

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3012 and nonfoodc <= 3012).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
3012 'Small applinces'
3013 'Large appliances'
3014 'Cloth dryer
3015'Dish washer'
3016 'Water tank'
3099 'Non consumption agregate'

RECODE Others  ( 155  =  3001) ( 234  =  3012) ( 235  =  3012) ( 323  =  3014) ( 324  =  3014) ( 373  =  3013) 
( 374  =  3013) ( 442  =  3015) ( 486  =  3014) ( 487  =  3014) ( 500  =  3012) ( 519  =  3012) ( 542  =  3012) 
( 558  =  3012) ( 572  =  3012) ( 573  =  3012) ( 574  =  3012) ( 575  =  3012) ( 576  =  3012) ( 608  =  3012) 
( 626  =  3012) ( 711  =  3012) ( 770  =  3012) ( 771  =  3012) ( 772  =  3012) ( 773  =  3012) ( 786  =  3012) 
( 787  =  3012) ( 788  =  3012) ( 789  =  3012) ( 804  =  3012) ( 909  =  3012) ( 910  =  3012) ( 962  =  3012) 
( 963  =  3012) ( 1113  =  3012) ( 1123  =  3012) ( 1124  =  3012) ( 1125  =  3012) ( 1126  =  3012) ( 1189  =  3012) 
( 1250  =  3013) ( 1251  =  3013) ( 1333  =  3012) ( 1417  =  3008) ( 1418  =  3008) ( 1419  =  3008) ( 1420  =  3008) 
( 1467  =  3012) ( 1502  =  3012) ( 1514  =  3002) ( 1515  =  3099) ( 1519  =  3012) ( 1520  =  3016) ( 1565  =  3012) 
INTO nonfoodc.
EXECUTE.

***   31 HH Linnens.

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3104 and nonfoodc <= 3104).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
3104 'Other linnes'


***   32 Glsswae, cuttlery.

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3203 and nonfoodc <= 3203).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
3203 'Other glassware and cuttlery'
3299 'Non consumption agregate'

RECODE Others   ( 506  =  3299) 
INTO nonfoodc.
EXECUTE.

***   33 Maintanence for vehicles.

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3306 and nonfoodc <= 3307).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
3306 'Repairs, improvements'
3399 'Non consumption agregate'

RECODE Others ( 111  =  3306) ( 151  =  3306) ( 175  =  3306) ( 176  =  3306) ( 177  =  3306) 
( 179  =  3306) ( 180  =  3306) ( 241  =  3306) ( 243  =  3306) ( 244  =  3399) ( 245  =  3399) 
( 246  =  3399) ( 247  =  3399) ( 249  =  3399) ( 250  =  3399) ( 251  =  3306) ( 298  =  3306) 
( 353  =  3399) ( 509  =  3306) ( 510  =  3306) ( 511  =  3306) ( 512  =  3306) ( 518  =  3306) 
( 557  =  3399) ( 559  =  3399) ( 607  =  3399) ( 715  =  3399) ( 777  =  3399) ( 899  =  3399) 
( 935  =  3399) ( 951  =  3399) ( 964  =  3399) ( 965  =  3399) ( 966  =  3399) ( 967  =  3399) 
( 970  =  3399) ( 988  =  3306) ( 989  =  3306) ( 990  =  3306) ( 995  =  3306) ( 996  =  3306) 
( 997  =  3306) ( 1014  =  3399) ( 1015  =  3399) ( 1016  =  3399) ( 1081  =  3399) 
( 1173  =  3306) ( 1237  =  3399) ( 1238  =  3399) ( 1239  =  3399) ( 1241  =  3399) 
( 1242  =  3399) ( 1243  =  3399) ( 1263  =  3399) ( 1270  =  3399) ( 1361  =  3399) 
( 1434  =  3399) ( 1444  =  3306) ( 1445  =  3306) ( 1458  =  3399) ( 1459  =  3399) 
( 1468  =  3399) ( 1469  =  3399) ( 1470  =  3399) ( 1471  =  3399) ( 1474  =  3399) 
( 1475  =  3399) ( 1508  =  3399) 
INTO nonfoodc.
EXECUTE.

***   34 Insurance and durables.

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3405 and nonfoodc <= 3405).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  

RECODE Others 
( 727  =  3503) ( 925  =  3403) ( 1038  =  3502) ( 1176  =  3501) 
( 1225  =  3402) ( 1476  =  3401) ( 1480  =  3403) 
INTO nonfoodc.
EXECUTE.

***   35 Licenses  .

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3503 and nonfoodc <= 3504).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  

RECODE Others ( 220  =  3502) ( 480  =  3502) ( 481  =  3502) ( 482  =  3808) 
( 483  =  3502) ( 700  =  3502) ( 726  =  3501) ( 727  =  3501) ( 907  =  3502) 
( 926  =  3502) ( 1037  =  3502) ( 1039  =  3502) ( 1175  =  3501) ( 1177  =  3501) 
( 1381  =  3501) ( 1477  =  3502) ( 1481  =  3403) ( 1529  =  3501) ( 1567  =  3502) 
INTO nonfoodc.
EXECUTE.

RECODE nonfoodc (3503=3502).
EXECUTE.

***   36 other travel expenses .

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3602 and nonfoodc <= 3602).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
3602 'Other, other travel'

RECODE Others  (71= 3601) (388= 3601)
INTO nonfoodc.
EXECUTE.

***   37 Education, recreation .

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3709 and nonfoodc <= 3709).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
3709 'Other entertaiment'
3799 'Non consumption agregate'

RECODE Others ( 916  =  3799) ( 643  =  3306) ( 150  =  3404) 
( 746  =  3704) ( 747  =  3704) ( 954  =  3704) ( 1079  =  3705) 
INTO nonfoodc.
EXECUTE.

**   38 Other services .

USE ALL.
COMPUTE filter_$=(nonfoodc >=  3808 and nonfoodc <= 3811).
FILTER BY filter_$.
EXECUTE.

FREQUENCIES VARIABLES=Others
  /ORDER=ANALYSIS.

***New codes  
3808 'Other, other services'
3899 'Non consumption agregate'

RECODE Others  ( 104  =  3808) ( 105  =  3808) ( 106  =  3808) ( 149  =  3404) 
( 152  =  3808) ( 153  =  3808) ( 154  =  3808) ( 242  =  3899) ( 259  =  3808) 
( 300  =  3899) ( 313  =  3808) ( 372  =  3808) ( 375  =  3808) ( 416  =  3808) 
( 474  =  3808) ( 478  =  3808) ( 586  =  3899) ( 587  =  3899) ( 713  =  3808) 
( 803  =  3808) ( 823  =  3808) ( 827  =  3808) ( 828  =  3808) ( 837  =  3808) 
( 865  =  3899) ( 868  =  3808) ( 900  =  3899) ( 939  =  3899) ( 960  =  3808) 
( 1017  =  3808) ( 1018  =  3808) ( 1019  =  3808) ( 1020  =  3808) ( 1310  =  3808) 
( 1380  =  3899) ( 1382  =  3899) ( 1386  =  3808) ( 1429  =  3808) 
INTO nonfoodc.
EXECUTE.

FILTER OFF.
USE ALL.
EXECUTE.

Value label  nonfoodc 1101  "1101 House rent - private owner"    1102  "1102 House rent - government"  1103  "1103 Mortgage"  1104  "1104 House insurance"  
1105 "Others"  1106 "Land rent"  1107 "Rent and utilities"  1199 "Non consumption aggregate"   1201  "1201 Electricity"  1202  "1202 Kerosene"  
1203  "1203 Natural gas"  1204  "1204 Bottled gas"  1205  "1205 Water supply"  1206  "1206 Matches"  1207 "Other light and fuel"  1208 "Other water or light"  
1299 "Non consumption aggregate"   1301  "1301 Laundry Soap (Bars)"  1302  "1302 Liquid Bleach"    1303  "1303 Liquid Detergent"  1304  "1304 Soap Powder (Detergent)"  
1305  "1305 Spray Starch"  1306  "1306 Toilet Cleaners"  1307 "Other soaps and detergents"  1308 "Other similar cleaning products"  1401  "1401 Broom Bodies and Handles"  
1402  "1402 Disinfectants and Antiseptics"  1403  "1403 Mops"      1404  "1404 Scouring Powder and others"  1405  "1405 Steel Wool Scouring Pads"  
1407 "Other cleaning material"  1501  "1501 Aluminium Foil"  1502  "1502 Paper Towels and Napkins"  1503  "1503 Plastic Bags (food)"  1504  "1504 Herbicides"  
1505  "1505 Insecticides"  1506  "1506 Mosquito Coil and Vape Mat"     1507 "Other Household supplies"  1601  "1601 Antiperspirant"  1602  "1602 Baby Napkins of paper Pulp"  
1603  "1603 Cosmetics and others"  1604  "1604 Hair Relaxer, Straightener, etc"  1605  "1605 Medicated Soap"  1606  "1606 Perfumes and Toilet Waters"  
1607  "1607 Petroleum Jelly"  1608  "1608 Razors"  1609  "1609 Sanitary Napkins of Paper"  1610  "1610 Shampoo"  1611  "1611 Toilet Paper"  
1612  "1612 Toilet Soap (cakes)"  1613  "1613 Tooth Brushes"   1614  "1614 Toothpaste"  1615  "1615 Baby diapers"  1616  "1616 Diapers for adults"  
1617 "Other Household supplies"  1701  "1701 Medical insurance"  1702 "Life insurance"  1799 "Non consumption aggregate"   1801  "1801 Internet, phone and TV fees"    
1802  "1802 Mobile phone fee"  1803 "Other phone charges"   1899 "Non consumption"  1901  "1901 Pens and pencils"  1902  "1902 Notebooks"  1903  "1903 Other (specify)"  
2001  "2001 Maid"  2002  "2002 Haidresser"  2003  "2003 Beauty Shop"  2004  "2004 Barber"  2005  "2005 Ggym Fees"  2006 "Other services"  2099 "Non consumption"  
2101  "2101 Jeans"  2102  "2102 Shirts"  2103  "2103 Shorts"  2104  "2104 Suits"  2105  "2105 Trousers (not jeans)"  2106  "2106 T-shirts"  2107  "2107 Briefs"  
2108  "2108 Socks"  2109  "2109 Under- Garments"  2110  "2110 Pyjamas"  2111  "2111 Boots"  2112  "2112 Footwear of outer soles and uppers"  2113  "2113 Sandals"  
2114  "2114 Leather shoes"  2115  "2115 Rubber shoes"  2116  "2116 Sneakers/ sport shoes"  2117 "Other clothes for men"  2201  "2201 Blouses"  2202  "2202 Dresses"  
2203  "2203 Jeans"  2204  "2204 Trousers (not jeans)"  2205  "2205 Shirts"  2206  "2206 T-shirts"  2207  "2207 Shorts"  2208  "2208 Skirts"  2209  "2209 Slacks"  
2210  "2210 Stockings and Panty Hose"  2211  "2211 Suits - Costumes"  2212  "2212 Brassieres"  2213  "2213 Panties"  2214  "2214 Pyjamas"  2215  "2215 Boots"  
2216  "2216 Footwear of outer soles and uppers"  2217  "2217 Sandals"  2218  "2218 Leather shoes"  2219  "2219 Rubber shoes"  2220  "2220 Sneakers/ sport shoes"  
2221 "Other clothes for women"  2301  "2301 Jeans"  2302  "2302 Shirts"  2303  "2303 Shorts"  2304  "2304 Suits"  2305  "2305 Trousers (not jeans)"  
2306  "2306 T-shirts"  2307  "2307 Briefs"  2308  "2308 Socks"  2309  "2309 Under- Garments"  2310  "2310 Pyjamas"  2311  "2311 Boots"  2312  "2312 Footwear of outer soles and uppers"  
2313  "2313 Sandals"  2314  "2314 Leather shoes"  2315  "2315 Rubber shoes"  2316  "2316 Sneackers/ sport shoes"  2317 "Other clothes for boys"  
2399 "Non consumption agregate"  2401  "2401 Blouses"  2402  "2402 Dresses"  2403  "2403 Jeans"  2404  "2404 Trousers (not jeans)"  2405  "2405 Shirts"  
2406  "2406 T-shirts"    2407  "2407 Shorts"  2408  "2408 Skirts"  2409  "2409 Slacks"  2410  "2410 Stockings"  2411  "2411 Suits - Costumes"  2412  "2412 Panties"  
2413  "2413 Pyjamas"  2414  "2414 Boots"  2415  "2415 Footwear of outer soles and uppers"  2416  "2416 Sandals"  2417  "2417 Leather shoes"  2418  "2418 Rubber shoes"  
2419  "2419 Sneakers/ sport shoes"     2420 "Other clothes for girls"      2499 "Non consumption agregate"  2501  "2501 Fabrics - for females"  2502  "2502 Fabrics - for males"  
2503  "2503 Hand Bag (Leather)"  2504  "2504 Jewellery of Gold"  2505  "2505 Jewellery of Silver"  2506  "2506 Watches - for females"  2507  "2507 Watches - for males"  
2508  "2508 Belts"  2509 "Jewellery"  2510 "Other clothing and accessory"  2599 "Non consumption agregate"  2601  "2601 Building Cement - (Grey)"  
2602  "2602 Ceramic Sinks"  2603  "2603 Coniferous wood, Planed, Tongued, etc"  2604  "2604 Doors"  2605  "2605 Galvanized Sheets and Ridge Caps"  
2606  "2606 Paints - Emulsion"  2607  "2607 Paints - Gloss"  2608  "2608 Paints (not Stated)"  2609  "2609 Pitch Pine and Deal"  2610  "2610 Vinyl and Vinyl Tiles"  
2611  "2611 Windows"  2612  "2612 Wood - Green Heart"  2613  "2613 Other (Specify)"  2614  "2614 Other (Specify)"  2615  "2615 Other (Specify)" 2616  "2616 Other (Specify)"  
2617  "2617 Other (Specify)"  2701  "2701 Labour charges - Carpenters"  2702  "2702 Labour charges - Electricians"  2703  "2703 Labour charges - Labourers"  
2704  "2704 Labour charges - Masons"  2705  "2705 Labour charges - Painters"  2706  "2706 Labour charges - Plumbers"  2707  "2707 Other (Specify)"  
2801  "2801 Flat-screen TV"  2802  "2802 Colour television set"  2803  "2803 DVD player"  2804  "2804 Digital music player"  2805  "2805 Portable radios"  
2806  "2806 Digital video camera"  2807  "2807 Mobile phone"  2808 "Android devices"  2809 "Other electronics"  2810 "Other electonic accesories"  
2901  "2901 Bed"  2902  "2902 Bed Stead"  2903  "2903 Carpets"  2904  "2904 Chairs"  2905  "2905 Chest of Drawers"  2906  "2906 Dining Room Suite"  
2907  "2907 Drapes & curtains"  2908  "2908 Kitchen Cabinet"  2909  "2909 Living Room Suite"  2910  "2910 Mattresses"  2911  "2911 Small Furnishings"  
2912  "2912 Wardrobes"  2913  "2913 Table"  2914  "2914 Standard lamp"  2915  "2915 Bedside lamp"  2916 "Other furniture"  3001  "3001 Blenders"  
3002  "3002 Washing Machines"  3003  "3003 Deep Freezers"  3004  "3004 Refrigerators"  3005  "3005 Electric Irons"  3006  "3006 Electric Stoves"  
3007  "3007 Gas Stoves"  3008  "3008 Micro-wave and Toasters"  3009  "3009 Room Fans"  3010  "3010 Vacuum Cleaners"  3011  "3011 Air Conditioner"  
3012 "Small applinces"  3013 "Large appliances"  3014 "Cloth dryer"   3015"  Dish washer"  3016 "Water tank"  3099 "Non consumption agregate"   
3101  "3101 Bed Linen"  3102  "3102 Towel"  3103  "3103 Tablecloth"  3104 "Other linnes"  3201  "3201 Kitchen or Tableware (e.g. Forks etc.)"  
3202  "3202 Dishes, Plates etc."  3203 "Other glassware and cuttlery"  3299 "Non consumption agregate"  3301  "3301 Batteries"  3302  "3302 Car parts - other"  
3303  "3303 New Tyres for Motor Cars"  3304  "3304 Service - Tune-up; grease & spray"  3305  "3305 Wages to Mechanic"  3306 "Repairs, improvements"  
3399 "Non consumption agregate"  3401  "3401 Motor Car - Purchase"  3402  "3402 Motor Cycle - Purchase"  3403  "3403 Vehicle Insurance - Purchase"  
3404  "3404 Bicycle - Purchase"  3501  "3501 Vehicle Registration Fee"  3502  "3502 Drivers Licenses Fee (Renew)"  3601  "3601 Travel - Return Airfare"  
3602 "Other, other travel"  3701  "3701 Toys"  3702  "3702 PC (personal computer)"  3703  "3703 Laptop"  3704  "3704 Tablet"  3705  "3705 Viideo game console"  
3706  "3706 Computer peripherals"  3707  "3707 Musical instruments"  3708  "3708 Holidays or tours (all-inclusive)"  3709 "Other entertaiment"  
3799 "Non consumption agregate"  3801  "3801 Dress-making"  3802  "3802 Tailoring"  3803  "3803 Appliance and equipment Repairs"  3804  "3804 Legal Fees"  
3805  "3805 Property/ land taxes"  3806  "3806 Weddings"  3807  "3807 Funerals"  3808 "Other, other services"  3899 "Non consumption agregate"      .

***ID non consumption codes: This includes 
***   1  morgages and land rent
***   2 all codes ending in 99, which are the "others" classified as non consumptio.
***   3 all codes 26 building materials
***   4  all codes 27, repairs and maitanence .
***   5 Property taxes and funerals
***

compute consu_code = 1 .
DO IF ( nonfoodc = 1103  or  nonfoodc = 1106
 or  nonfoodc = 1199 or  nonfoodc = 1299 or  nonfoodc = 1799 or  nonfoodc = 1899 or  nonfoodc = 2099
 or  nonfoodc = 2399 or  nonfoodc = 2499 or  nonfoodc = 2599 or  nonfoodc = 3099 or  nonfoodc = 3299
 or  nonfoodc = 3399 or  nonfoodc = 3799 or  nonfoodc = 3899
 or  nonfoodc = 2601 or  nonfoodc = 2602 or  nonfoodc = 2603
 or  nonfoodc = 2604 or  nonfoodc = 2605 or  nonfoodc = 2606 or  nonfoodc = 2607
 or  nonfoodc = 2608 or  nonfoodc = 2609 or  nonfoodc = 2610 or  nonfoodc = 2611
 or  nonfoodc = 2612 or  nonfoodc = 2613 or  nonfoodc = 2614 or  nonfoodc = 2615
 or  nonfoodc = 2616 or  nonfoodc = 2617 or  nonfoodc = 2701 or  nonfoodc = 2702
 or  nonfoodc = 2703 or  nonfoodc = 2704 or  nonfoodc = 2705 or  nonfoodc = 2706
 or  nonfoodc = 2707  
 or  nonfoodc = 3805  or  nonfoodc = 3807 ).
RECODE consu_code (1=0).
END IF.
EXECUTE.

***maid expenses will not be included for living in maids. 

SORT CASES BY hhid(A) nonfoodc(A).

***add living in serventas information .

MATCH FILES /FILE=*
  /TABLE='C:\1 Barbados\analisys\c hh with sevents.sav'
  /RENAME (hhid_string = d0) 
  /BY hhid nonfoodc
  /DROP= d0.
EXECUTE.

RECODE living_sevents (SYSMIS=0).
EXECUTE.

DO IF (nonfoodc = 2001  and  living_sevents = 1).
RECODE consu_code (1=0).
END IF.
EXECUTE.

***Also, codes for durables with information for every houshold ownership (new or old).

compute durables = 0 .
DO IF  (nonfoodc  =   3002   or   nonfoodc  =   3003   or   
nonfoodc  =   3004   or   nonfoodc  =   3006   or   nonfoodc  =   3007   or   nonfoodc  =   3011   or   
nonfoodc  =   3014   or   nonfoodc  =   3015   or    nonfoodc  =   3401   or   
nonfoodc  =   3402   or   nonfoodc  =   3702   or   nonfoodc  =   3703     ) .
RECODE durables (0=1).
END IF.
EXECUTE.

*consumption would be estimated using the values reported here and the housing repors.
***The objective is to have an estimated USE VALUE  (and not purchase value)

***Motorcicles do not have information in the housing section, bud due to therir high value, the use of
***purchase value is not recomended and  an diferent estimation would be used .

SORT CASES BY hhid(A)  nonfoodc (A) .

SAVE OUTFILE='c0 non food.sav'
  /COMPRESSED.

********************.

GET  FILE='c0 non food.sav'.

************************************************************************************************************



***Select only items for consumption aggregate.

.
GET  FILE='c0 non food.sav'.

***keep only observationswith consumption aggregate .

***   50, 634 lines .

FILTER OFF.
USE ALL.
SELECT IF (consu_code  = 1).
EXECUTE.

***  46,633 lines   .

***take out 12durables with average values close to BB$1,000 or more 
***and with an average of only 48 households reporting purchases..

***Durables                                           Average BB$            # of households                        
*  3002 3002 Washing Machines             1,517                          81
*  3003 3003 Deep Freezers                    937                             20
*  3004 3004 Refrigerators                     1,918                          102
*  3006 3006 Electric Stoves                  1,159                            23
*  3007 3007 Gas Stoves                       1,404                           109
*  3011 3011 Air Conditioner                 4,028                               9
*  3014 Cloth dryer                                 1,616                                7
*  3015 Dish washer                                1,400                              2
*  3401 3401 Motor Car - Purchase     39,838                           87
*  3402 3402 Motor Cycle - Purchase   7,411                            21
*  3702 3702 PC (personal computer)    1,032                          12
*  3703 3703 Laptop                                    1,456                     101

FILTER OFF.
USE ALL.
SELECT IF (durables  = 0).
EXECUTE.

***  46,059lines   .

compute new_nonfoodc  = nonfoodc  .
execute.

RECODE new_nonfoodc (2005=37) (3001=3012) (3005=3012) (3403=35) (3701=37)  (3808=38) (1301 
    thru 1598=13) (1601 thru 1698=16) (1901 thru 1998=16) (1701 thru 1798=17) (1802 thru 1898=18) (2001 
    thru 2004=20) (2006 thru 2098=20) (2101 thru 2298=21) (2301 thru 2498=23) (2501 thru 2503=25) 
   (2508 thru 2598=25)  (2504 thru 2507=25.2) 
  (2803  thru 2806=28) (2809 thru 2810=28) (2901 thru 2998=29) (3008 thru 3010=3012) (3101 thru 3198=25) 
    (3201 thru 3298=29) (3301 thru 3398=33) (3501 thru 3598=35) (3601 thru 3698=37) (3706 thru 3798=37) 
    (3801 thru 3804=38)
    ( 3016=3012)   ( 2808=18)   ( 3704=37)   ( 2807=18)   ( 3705=37)     .
EXECUTE.

RECODE new_nonfoodc (2802=3013)    (1208=1201)  (1107=1101)  (3013=38)  (1105=38)  .
EXECUTE.

RECODE new_nonfoodc (3013=38)    .
EXECUTE.

Value labels    new_nonfoodc 13 "Cleanning and other HH supplies"   16 "Personal care and stationary"   17 "Health insurance"   
18 "Comunications"   20 "Other"   21 "Clothes adults"   23 "Clothes children"   25 "Clothes other"  25.2"Jewellery and watches" 
28 "Radio and other electroncs"   29 "Furniture and cutlery"   33 "Vehicle maitenance"   35 "Vehicle insurance, registration, license, etc."   
37 "Entertaiment"   38 "Other"   1101 "1101 House rent - private owner"   1102 "1102 House rent - government"   
1104 "1104 House insurance"      1201 "1201 Electricity"   1202 "1202 Kerosene"   
1203 "1203 Natural gas"   1204 "1204 Bottled gas"   1205 "1205 Water supply"   1206 "1206 Matches"   1207 "Other light and fuel"   
  2801 "2801 Flat-screen TV"     
 3012 "Small applinces"   3404 "3404 Bicycle - Purchase"   
3703 "3703 Laptop"     3806 "3806 Weddings"   3807 "3807 Funerals"      .


****Estimate montly expenditure .

COMPUTE amont_month=amount * anncoeff / 12.
EXECUTE.

AGGREGATE
  /OUTFILE=*
  /BREAK=hhid_string hhid weight psu stratum psus_N hhh_gender hh_size new_nonfoodc
  /amont_month 'Montly expenditure'=SUM(amont_month).

***21,779 lines .

variable level new_nonfoodc (nominal )      .

***The average house insurance is 926/month wichi is even higher than the average montly private rent  of 838
***The MEDIAN house insurance is 500/month wichi is close to 66% of the medianmontly private rent  of  790

***Since there are values as low as 33 wiith no clear frequency break, it looks like the questionnaire captured some 
***monlty payments, and somo yearly payments that were due the month of the interview.   Since there is no clear way
***to differenciate which one is which, and no way to know yearly payments made outside the month of the interview, this
***variable will be excluded.  

***For future surveys, it is recommende to ask this question in the "yearly" section, and help households with more frequent payments to
***estimate the yearly value.

FILTER OFF.
USE ALL.
SELECT IF (new_nonfoodc ~= 1104).
EXECUTE.

***21,594    lines .(254 eliminqted)  .

***identify outliers and missing cases and estimate values .

FREQUENCIES VARIABLES=new_nonfoodc
  /ORDER=ANALYSIS.

**************************************************  START  create specific data vairables ***************************************.
*Crear variable para transformar en per cápita.  Si no se ocupa, poner 1  .
COMPUTE PC= 1.
EXECUTE .
IF  ( new_nonfoodc  =  13 OR  new_nonfoodc  =  16 OR  new_nonfoodc  =  18 OR  new_nonfoodc  =  1201 
    OR  new_nonfoodc  =  1203 OR  new_nonfoodc  =  1205) PC=hh_size.
EXECUTE.
***define varible to be examined (Make sure cases with no service o item had a missing value) .
COMPUTE var=  amont_month/pc .
EXECUTE.
***ID missing cases .
COMPUTE lack_data = 0 .
IF  ( MISSING(var)) lack_data=1.
EXECUTE.
***Create variable for level of analysis.  If none use a "1" .
COMPUTE level=    new_nonfoodc .
EXECUTE.
*****************************************************  END  create specific data vairables ***************************************.

***Estandar deviationa from the mean . 

AGGREGATE
  /OUTFILE=* MODE=ADDVARIABLES
  /BREAK=level
  /var_mean=MEAN(var) 
  /var_sd=SD(var).

COMPUTE sd_mean=ABS(RND(   (var - var_mean)/var_sd,0.1)).
EXECUTE.

SORT CASES BY sd_mean(D).

****The examination and determination has to be done for each variable type 

EXAMINE VARIABLES=sd_mean
  /PLOT BOXPLOT
  /COMPARE GROUPS
  /STATISTICS DESCRIPTIVES
  /CINTERVAL 95
  /MISSING LISTWISE
  /NOTOTAL.

COMPUTE var_ex = 0.
EXECUTE.

FREQUENCIES VARIABLES=lack_data sd_mean
  /ORDER=ANALYSIS.

**************************************************  START  cut-off point for replacement  ******************************.
***Cases replaced:  69 (0.3%) + 260  missing:    329  .
IF  (sd_mean > 6.5  or lack_data=1) var_ex=var_mean * pc.
Compute var = var * pc .
IF  (sd_mean > 6.5 or lack_data=1) var=var_mean * pc .
EXECUTE.
**************************************************  END  cut-off point for replacement  ******************************.

RECODE var_ex var (SYSMIS=0).
EXECUTE.
FREQUENCIES VARIABLES= var var_ex 
  /ORDER=ANALYSIS.

**************************************************    START  define new varaibles   and save file       ******************************.

***Ctreate individual variables according to consumption groups .

IF  (new_nonfoodc = 1101) house1=var.
IF  (new_nonfoodc = 1101) house1_ex=var_ex .

IF  (new_nonfoodc = 1102) house2=var.
IF  (new_nonfoodc = 1102) house2_ex=var_ex .

IF  ((new_nonfoodc >= 1201 and  new_nonfoodc <= 1207) or  new_nonfoodc = 1801) h_services =var.
IF  ((new_nonfoodc >= 1201 and  new_nonfoodc <= 1207) or  new_nonfoodc = 1801)  h_services_ex =var_ex.

IF  (new_nonfoodc = 17) insurance=var.
IF  (new_nonfoodc = 17) insurance_ex=var_ex .

IF  (new_nonfoodc = 21  or new_nonfoodc = 23  or new_nonfoodc = 25  ) clothing=var.
IF  (new_nonfoodc = 21  or new_nonfoodc = 23  or new_nonfoodc = 25  ) clothing_ex=var_ex.

IF  (new_nonfoodc = 18  or new_nonfoodc = 33  or new_nonfoodc = 35  ) transport=var.
IF  (new_nonfoodc = 18  or new_nonfoodc = 33  or new_nonfoodc = 35  ) transport_ex=var_ex.

IF  (new_nonfoodc = 13  or new_nonfoodc = 16   ) personal =var   .
IF  (new_nonfoodc = 13  or new_nonfoodc = 16   ) personal_ex =var_ex .

IF  (new_nonfoodc = 37  or new_nonfoodc = 3806   ) fun =var   .
IF  (new_nonfoodc = 37  or new_nonfoodc = 3806   ) fun_ex =var_ex   .

IF  (new_nonfoodc = 25.2  or new_nonfoodc = 28  or new_nonfoodc = 29  or new_nonfoodc = 2801 or
new_nonfoodc = 3012  or new_nonfoodc = 3404  ) furniture=var   .
IF  (new_nonfoodc = 25.2  or new_nonfoodc = 28  or new_nonfoodc = 29  or new_nonfoodc = 2801 or
new_nonfoodc = 3012  or new_nonfoodc = 3404 ) furniture_ex=var_ex   .

IF  (new_nonfoodc = 20  or new_nonfoodc = 38   ) other =var   .
IF  (new_nonfoodc = 20  or new_nonfoodc = 38   ) other_ex =var_ex   .

execute .

VARIABLE LABELS  house1 'House rent private/month/household'.
VARIABLE LABELS  house1_ex 'Estimated house rent private/month/household'.

VARIABLE LABELS  house2 'House rent government/month/household'.
VARIABLE LABELS  house2_ex 'Estimated house rent government/month/household'.

VARIABLE LABELS  h_services 'Household services/month/household'.
VARIABLE LABELS  h_services_ex 'Estimated household services/month/household'.

VARIABLE LABELS  insurance 'Health insurance/month/household'.
VARIABLE LABELS  insurance_ex 'Estimated health insurance/month/household'.

VARIABLE LABELS  Clothing 'Clothing, shoes, fabricmonth/household'.
VARIABLE LABELS  Clothing_ex 'Estimated clothing, shoes, fabricmonth/household'.

VARIABLE LABELS  transport 'Transport and comunications/month/household'.
VARIABLE LABELS  transport_ex 'Estimated transport and comunications/month/household'.

VARIABLE LABELS personal  'Personal care, stationary, cleanning supplies/month/household'.
VARIABLE LABELS personal_ex  'Estimated personal care, stationary, cleanning supplies/month/household'.

VARIABLE LABELS  fun  'Recreation, wedings/month/household'.
VARIABLE LABELS  fun_ex  'Estimated recreation, wedings/month/household'.

VARIABLE LABELS furniture  'Furniture, small durables, electronics, electodomestics, etc./month/household'.
VARIABLE LABELS furniture_ex  'Estimated furniture, small durables, electronics, electodomestics, etc./month/household'.

VARIABLE LABELS  other  'Other consumption/month/household'.
VARIABLE LABELS  other_ex  'Estimated other consumption/month/household'.
EXECUTE.

SAVE OUTFILE='delete1.sav'
  /COMPRESSED.

********************.

GET  FILE='delete1.sav'.

RECODE house1 house1_ex house2 house2_ex h_services h_services_ex insurance insurance_ex clothing 
    clothing_ex transport transport_ex personal personal_ex fun fun_ex furniture furniture_ex other 
    other_ex (SYSMIS=0).
EXECUTE.

***verify all values are includec 

COMPUTE aaaa=var-house1-house2-h_services-insurance-clothing-transport-personal-fun-furniture-other.    

COMPUTE bbb=
    var_ex-house1_ex-house2_ex-h_services_ex-insurance_ex-clothing_ex-transport_ex-personal_ex-fun_ex-furniture_ex-other_ex.
EXECUTE.

FREQUENCIES VARIABLES=aaaa bbb
  /ORDER=ANALYSIS.

***All frequencies are 0  ... all values are included .

***Estimate totals for each group for each household.

AGGREGATE
  /OUTFILE=  *
  /BREAK=hhid_string hhid weight psu stratum hh_size
  /house1  =  SUM  (house1) 
  /house1_ex  =  SUM  (house1_ex) 
  /house2  =  SUM  (house2) 
  /house2_ex  =  SUM  (house2_ex) 
  /h_services  =  SUM  (h_services) 
  /h_services_ex  =  SUM  (h_services_ex) 
  /insurance  =  SUM  (insurance) 
  /insurance_ex  =  SUM  (insurance_ex) 
  /clothing  =  SUM  (clothing) 
  /clothing_ex  =  SUM  (clothing_ex) 
  /transport  =  SUM  (transport) 
  /transport_ex  =  SUM  (transport_ex) 
  /personal  =  SUM  (personal) 
  /personal_ex  =  SUM  (personal_ex) 
  /fun  =  SUM  (fun) 
  /fun_ex  =  SUM  (fun_ex) 
  /furniture  =  SUM  (furniture) 
  /furniture_ex  =  SUM  (furniture_ex) 
  /other  =  SUM  (other) 
  /other_ex  =  SUM  (other_ex).


***PUT 0'S AND LABELS  ..

RECODE house1 house1_ex house2 house2_ex h_services h_services_ex insurance insurance_ex clothing 
    clothing_ex transport transport_ex personal personal_ex fun fun_ex furniture furniture_ex other 
    other_ex (SYSMIS=0).
EXECUTE.

VARIABLE LABELS  house1 'House rent private/month/household'.
VARIABLE LABELS  house1_ex 'Estimated house rent private/month/household'.

VARIABLE LABELS  house2 'House rent government/month/household'.
VARIABLE LABELS  house2_ex 'Estimated house rent government/month/household'.

VARIABLE LABELS  h_services 'Household services/month/household'.
VARIABLE LABELS  h_services_ex 'Estimated household services/month/household'.

VARIABLE LABELS  insurance 'Health insurance/month/household'.
VARIABLE LABELS  insurance_ex 'Estimated health insurance/month/household'.

VARIABLE LABELS  Clothing 'Clothing, shoes, fabricmonth/household'.
VARIABLE LABELS  Clothing_ex 'Estimated clothing, shoes, fabricmonth/household'.

VARIABLE LABELS  transport 'Transport and comunications/month/household'.
VARIABLE LABELS  transport_ex 'Estimated transport and comunications/month/household'.

VARIABLE LABELS personal  'Personal care, stationary, cleanning supplies/month/household'.
VARIABLE LABELS personal_ex  'Estimated personal care, stationary, cleanning supplies/month/household'.

VARIABLE LABELS  fun  'Recreation, wedings/month/household'.
VARIABLE LABELS  fun_ex  'Estimated recreation, wedings/month/household'.

VARIABLE LABELS furniture  'Furniture, small durables, electronics, electodomestics, etc./month/household'.
VARIABLE LABELS furniture_ex  'Estimated furniture, small durables, electronics, electodomestics, etc./month/household'.

VARIABLE LABELS  other  'Other consumption/month/household'.
VARIABLE LABELS  other_ex  'Estimated other consumption/month/household'.
EXECUTE.

* Custom Tables.
CTABLES
  /VLABELS VARIABLES=house1 house2 h_services insurance clothing transport personal fun furniture 
    other 
    DISPLAY=DEFAULT
  /TABLE house1 [MEAN, COUNT F40.0, SUM, MEDIAN] + house2 [MEAN, COUNT F40.0, SUM, MEDIAN] + 
    h_services [MEAN, COUNT F40.0, SUM, MEDIAN] + insurance [MEAN, COUNT F40.0, SUM, MEDIAN] + clothing 
    [MEAN, COUNT F40.0, SUM, MEDIAN] + transport [MEAN, COUNT F40.0, SUM, MEDIAN] + personal [MEAN, 
    COUNT F40.0, SUM, MEDIAN] + fun [MEAN, COUNT F40.0, SUM, MEDIAN] + furniture [MEAN, COUNT F40.0, 
    SUM, MEDIAN] + other [MEAN, COUNT F40.0, SUM, MEDIAN].

SORT CASES BY hhid(A)   .

SAVE OUTFILE='c1 non food.sav'
  /COMPRESSED.

********************.

GET  FILE='c1 non food.sav'.

erase file "delete1.sav".

